//------------------------------------------------------------------------------
//     ___________ __  ___   _____ __  ________                     _____
//    / ____/ ___//  |/  /  / ___//  |/  / ___/   _________  ____  / __(_)___ _
//   / / __ \__ \/ /|_/ /   \__ \/ /|_/ /\__ \   / ___/ __ \/ __ \/ /_/ / __ `/
//  / /_/ /___/ / /  / /   ___/ / /  / /___/ /  / /__/ /_/ / / / / __/ / /_/ /
//  \____//____/_/  /_/   /____/_/  /_//____/   \___/\____/_/ /_/_/ /_/\__, /
//                                                                  /____/
//
// KONFIGURACNI APLIKACE PRO SMS I/O KARTU v 0.2, cfg.cpp
// 25.5.2005
//
//------------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#include <IniFiles.hpp>
#pragma hdrstop
#include "cfg.h"

//------------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"

//------------------------------------------------------------------------------
TForm1 *Form1;
BYTE err = 0;
BYTE port;
unsigned char init = 0xFF;

//- KONSTRUKTOR FORMU ----------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner):TForm(Owner)
{
}

//- NAHRANI KONFIGURACE Z INI SOUBORU ------------------------------------------
void LoadFormIni()
{
  int Confirm;
  TIniFile *IniSoubor = new TIniFile(ChangeFileExt(Application->ExeName, ".INI" ));     //vytvoreni obektu s ini souborem
  Form1->Left = IniSoubor->ReadInteger("Form","Left",0);                        //nactemi si pozici formu
  Form1->Top = IniSoubor->ReadInteger("Form","Top",0);
  port = IniSoubor->ReadBool("Main","COMPort", 0);                              //com cort 0=COM1, 1=COM2
  Form1->CheckBox1->Checked = IniSoubor->ReadBool("Main","RingCH", 0);          //RING ON/OFF
  Form1->CSpinEdit1->Value = IniSoubor->ReadInteger("Main","RingNR", 0);
  Confirm = IniSoubor->ReadInteger("Main","Confirm", 0);                        //potvrzeni
  Form1->MaskEdit1->Text = IniSoubor->ReadString("Nr","PrimNR","");             //primarni cislo
  Form1->MaskEdit2->Text = IniSoubor->ReadString("Nr","Sec1NR","");             //sekundarni cislo1
  Form1->CheckBox3->Checked = IniSoubor->ReadBool("Nr","Sec1CH", 0);
  Form1->MaskEdit3->Text = IniSoubor->ReadString("Nr","Sec2NR","");             //sekundarni cislo2
  Form1->CheckBox4->Checked = IniSoubor->ReadBool("Nr","Sec2CH", 0);
  delete IniSoubor;                                                             //zruseni IniSoubor
  if ((Confirm > 2)||(Confirm < 0)) Confirm = 0;
  Form1->ComboBox1->ItemIndex = Confirm;                                        //nastaveni comboboxu...
}

//- ULOZENI KONFIGURACE DO INI SOBORU ------------------------------------------
void SaveToIni()
{
  try                                                                           //protoze tato operace muze krachnout tak v kryticke sekci
  {
    TIniFile *IniSoubor = new TIniFile(ChangeFileExt(Application->ExeName, ".INI" ));
    IniSoubor->WriteInteger("Form","Left",Form1->Left);
    IniSoubor->WriteInteger("Form","Top",Form1->Top);
    IniSoubor->WriteBool("Main", "COMPort", port);
    IniSoubor->WriteBool("Main", "RingCH", Form1->CheckBox1->Checked);
    IniSoubor->WriteInteger("Main","RingNR", Form1->CSpinEdit1->Value);
    IniSoubor->WriteInteger("Main","Confirm", Form1->ComboBox1->ItemIndex);
    IniSoubor->WriteString("Nr","PrimNR",Form1->MaskEdit1->Text);
    IniSoubor->WriteString("Nr","Sec1NR",Form1->MaskEdit2->Text);
    IniSoubor->WriteBool("Nr", "Sec1CH", Form1->CheckBox3->Checked);
    IniSoubor->WriteString("Nr","Sec2NR",Form1->MaskEdit3->Text);
    IniSoubor->WriteBool("Nr", "Sec2CH", Form1->CheckBox4->Checked);
    delete IniSoubor;
  }
  catch(Exception &exception) {};
}

//- PRO PREPINANI COM PORTU----------------------------------------------------- 
void ShowCOM()
{
  if (!port) Form1->StatusBar1->Panels->Items[0]->Text = "Port: COM1";
  else Form1->StatusBar1->Panels->Items[0]->Text = "Port: COM2";
}

//- PRO FUNKCI ZASKRKAVATEK ----------------------------------------------------
void __fastcall TForm1::CheckBox(TObject *Sender)
{
  CSpinEdit1->Enabled = CheckBox1->Checked;
  MaskEdit2->Enabled = CheckBox3->Checked;
  MaskEdit3->Enabled = CheckBox4->Checked;
}

//- FORM CREATE - TEST EXISTENCE POTREBNYCH SOUSOBRU ---------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  if (!FileExists("bin\\batchIsp.exe"))
  {
    MessageBox(Handle, "Nenalezen soubor \"bin\\batchIsp.exe\" (ISP-batch jdro) !!     \n\nNainstalujte FLIP 2.4 (www.atmel.com).", "CHYBA", MB_ICONERROR);
    err = 1;
  }
  if (!FileExists("bin2hex.exe")&&(err==0))
  {
    MessageBox(Handle, "Nenalezen soubor \"bin2hex.exe\" (pevodnk z BIN na INTELHEX) !!    \n\nReinstalujte program.", "CHYBA", MB_ICONERROR);
    err = 1;
  }
  if (!FileExists("isp.bat")&&(err==0))
  {
    MessageBox(Handle, "Nenalezen soubor \"isp.bat\" (isp dvka) !!     \n\nReinstalujte program.", "CHYBA", MB_ICONERROR);
    err = 1;
  }
  if (err) RunBTN->Enabled = false;                                             //pri chybejicim souboru "vysvit" tlacitko RUN
  LoadFormIni();                                                                //nacteni konfigurace
  ShowCOM();                                                                    //info o portu
}

//- OPERACE FLASHOVANI ---------------------------------------------------------
//
// Konfiguracni string:
// <ring cfg(1)><init out(1)><confirm (1)><prim1(max14)>A<sec1(max14)>B<sec2(max14)>C<info>
//
//------------------------------------------------------------------------------
void __fastcall TForm1::RunBTNClick(TObject *Sender)
{
  FILE *soubor;
  BYTE err = true;
  char buffer[60] = "";
  hyper	i1, i2, i3;
  err = TryStrToInt64(MaskEdit1->Text,i1);                                      //osetreni chyboveho zadani cisla
  if ((err)&&(CheckBox3->Checked)) err = TryStrToInt64(MaskEdit2->Text,i2);
  if ((err)&&(CheckBox4->Checked)) err = TryStrToInt64(MaskEdit3->Text,i3);

  if ((err)&&(i1 > 9999))
  {
    if (IDCANCEL == MessageBox(Handle, "Aktivujte ISP bootloader, aby mohla bt nahrna konfigurace.    \n\nPro proveden tto operace je poteba provst:\nBL jumper        - sepnut\nRX-SW jumper - nastaven na RS232\nRST jumper      - provete reset hw", "VZVA", MB_OKCANCEL+MB_ICONINFORMATION)) return;
    if (!CheckBox1->Checked) buffer[0] = 9;
    else buffer[0] = Char(CSpinEdit1->Value);                                   //poskladani stringu
    buffer[1] = init;
    buffer[2] = ComboBox1->ItemIndex+1;
    strcat(buffer, IntToStr(i1).c_str());
    strcat(buffer, "A");
    if (CheckBox3->Checked) strcat(buffer, IntToStr(i2).c_str());
    strcat(buffer, "B");
    if (CheckBox4->Checked) strcat(buffer, IntToStr(i3).c_str());

    strcat(buffer, "C (<Cfg v0.2> ");
    strcat(buffer,FormatDateTime("dd.mm, hh:mm", Now()).c_str());               //pridani jeste data a casu konfigurace
    strcat(buffer, ")     ");

    if ((soubor = fopen("config.bin", "w")) == NULL) MessageBox(Handle, "Nelze vytvoit soubor \"config.bin\".    ", "CHYBA", MB_ICONWARNING);
    else
    {
      fprintf(soubor, buffer);                                                  //ulozeni do souboru
      fclose(soubor);
      if (!port) WinExec("isp.bat",SW_SHOW);                                    //spusteni davky
      else WinExec("isp.bat /2",SW_SHOW);
    }
  }
  else MessageBox(Handle, "Jedno i vce sel je chybn zadno.      ", "CHYBA", MB_ICONWARNING);
}

//- PREPINANI PORTU (COM1)------------------------------------------------------
void __fastcall TForm1::COM11Click(TObject *Sender)
{
  port = 0;
  ShowCOM();
}

//- PREPINANI PORTU (COM2)------------------------------------------------------
void __fastcall TForm1::COM21Click(TObject *Sender)
{
  port = 1;
  ShowCOM();
}

//- HELP VE STATUS BARU --------------------------------------------------------
void __fastcall TForm1::Help(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  String help = "";
  help = ((TButton*)Sender)->Hint;
  StatusBar1->Panels->Items[1]->Text = help;
}

//- VYTVORENI KONFIGURACNIHO BYTU ----------------------------------------------
void __fastcall TForm1::InitClick(TObject *Sender)
{
  init = 128*In1->Checked+64*In2->Checked+32*In3->Checked+16*In4->Checked+8*In5->Checked+4*In6->Checked+2*In7->Checked+1*In8->Checked;
  Edit1->Text=IntToStr(init);
}

//- ZOBRAZENI INFO TEXTAKU -----------------------------------------------------
void __fastcall TForm1::Info(TObject *Sender)
{
  WinExec("notepad.exe CONFIG.TXT",SW_SHOW);
}

//- PRI UKONCENI ZAVOLEJ ULOZENI KONFIGURACE -----------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  SaveToIni();
}
//------------------------------------------------------------------------------
