// -----------------------------------------------------------------------------------------------------
//
//   MT.C
//
//   rutiny pro praci s MT rady x35, 13.4.2005
//   (na platforme nezavisly kod)
//
// -----------------------------------------------------------------------------------------------------

#include <mt.h>
#include <str.h>
#include <ctype.h>
#include <string.h>


// - TEST VSTUPNIHO BUFFERU NA "PROZVONENI" ------------------------------------------------------------
//
//   VST:  char *ibuffer               - vstupni bufer pro testovani na "prozvoneni"
//         buflen                      - delka vstupniho bufferu
//   VYST: char *obuffer; return *char - string cisla jez "prozvonilo"
// -----------------------------------------------------------------------------------------------------
char *bufTestRING(char *ibuffer, char *obuffer, char buflen)
{
  char idata pos;
  obuffer[0]='\0';													//vymazani vystupniho bufferu
  if (buflen < 15) return obuffer;									//test delky
  pos = strrpos(ibuffer, 'I');										//hledani 'I' ve slove CLIP
  if ((pos == -1) || (ibuffer[pos+1] != 'P')) return obuffer;
  pos = strpos(ibuffer, ':')+3;										//pozice zacatku cisla
  copy(ibuffer, obuffer, pos, strpos(ibuffer, ',')-pos);			//kopie cisla
  return obuffer;
}

// - TEST VSTUPNIHO BUFFERU NA PRICHOZI SMS ------------------------------------------------------------
//
//   VST:  char *ibuffer               - vstupni bufer pro testovani na existenci oznameni nove SMS
//         buflen                      - delka vstupniho bufferu
//   VYST: char *obuffer; return *char - string jez udava cislo pozice SMS na sim-karte
// -----------------------------------------------------------------------------------------------------
char *bufTestSMS(char *ibuffer, char *obuffer, char buflen)
{
  char idata pos;
  obuffer[0]='\0';													//vymazani vystupniho bufferu
  if (buflen < 10) return obuffer;									//prilis kratke na prikaz
  pos = strpos(ibuffer, ',');										//nalezeni carky v textu +CMTI: "SM",6
  if ((strlen(ibuffer) > 10)&&(pos != -1)&&(ibuffer[pos-1] == '"')) //test spravnosti textu
  {
    copy(ibuffer, obuffer, pos+1, 2);								//zkoripovani cisla
    if (!isdigit(obuffer[1])) obuffer[1] = '\0';					//vynulovani horniho byte
  }
  return obuffer;
}

// - DEKODOVANI CISLA SMSC -----------------------------------------------------------------------------
//
//   VST:  char *test - vstupni buffer
//   VYST: char *nr   - nekodovane cislo
//         return bit - zpravnost dekodovani (1 - uspesne prevedeno)
// -----------------------------------------------------------------------------------------------------
bit readSMSC(char *text, char *nr)
{
  char idata pom;
  copy(text,nr,strpos(text,':')+4,strpos(text,',')-strpos(text,':')-5);   
  pom = strlen(nr);
  if ((pom < 9)||(pom > 14)) return 0;
  else return 1;
}

// - TEST NA EXISTENCI ZNAKU "OK" V BUFFERU ------------------------------------------------------------
//
//   VST:  char *vst - buffer
//   VYST: return bit - potvrzeni existence
// -----------------------------------------------------------------------------------------------------
bit oktest(char *vst)
{
  unsigned char idata pos;
  pos = strrpos(vst, 'O');								//test existence znaku OK
  if ((pos == -1) || (vst[pos+1] != 'K')) return 0;
  return 1;
}

// - TEST NA EXISTENCI ZNAKU "ERROR" V BUFFERU ---------------------------------------------------------
//
//   VST:  char *vst  - buffer
//   VYST: return bit - potvrzeni existence
// -----------------------------------------------------------------------------------------------------
bit errtest(char *vst)
{
  unsigned char idata pos;
  pos = strrpos(vst, 'O');								//test existence znaku ERROR
  if ((pos == -1) || (vst[pos+1] != 'R')) return 0;
  return 1;
}

// - DEKODOVANI SMS V PUD FORMATU ----------------------------------------------------------------------
//
//   VST:  char *in   - vstupni SMS zprava v PDU formatu
//   VYST: char *in   - dekodovany text
//         char *nr   - dekodovane cislo odesilatele SMS
//         return bit - stav provedeni dekodovani:
//                       0 - prevod OK
//                      -1 - nenelezen znak \r
//                      -2 - nezmane kodovani (neni ani 7b ani 8b)
//                      -3 - neukonceno OK
//                      -4 - nedostatecna delka vstupniho buferu
//						-5 - nejspis dorucenka raci ignoruju
// -----------------------------------------------------------------------------------------------------
char decodeSMS(char *in, char *nr)
{
  int idata pos = 0;      			                    //pozice v buffer
  unsigned char idata pom, pom2, pom3;					//univerzalni promene
  char idata bfr[3];									//pro nacitani znakovych dvojic
  unsigned char idata odkl, odkl2;						//odkladaci buffer
  char idata maskovadlo = 0;							//promena urcena pro maskovani prenosu
  unsigned char idata nrch;								//pocet znaku ve zprave
  bit idata cod7bit = 1;

// - zakladni testy buferu -----------------------------------------------------------------------------
  in[0] = ' ';											//odstraneni prvniho znaku \r
  if (in[1] == 'F')	return -5;							//snad osetreni dorucenek
  if (strlen(in) < 30) return -4;						//test delky bufferu
  if (!oktest(in)) return -3;							//test existence znaku OK
// - dekodovani cisla, preskakovani informaci o case, atd... -------------------------------------------
  if ((pos = strpos(in, '\r')) != -1)
  {
    pom = hex2bin(copy(in, bfr, pos +1, 2));			//preskoceni SMSC informace a DELIVER PDU
    pos = pos + pom*2 + 5;
    pom = hex2bin(copy(in, bfr, pos, 2)); 				//nacteni delky telefonic cisla
    if (in[pos+4] == 'F') pos++;						//pro lichy pocet cislic v cislu
    copy(in, nr, pos+4, pom);							//kopie cisla
  	for (pom2 = 0; pom2 < pom; pom2=pom2+2)				//swap cisla
	{
      if (nr[pom2+1] != 0)
      {
        odkl = nr[pom2];
        nr[pom2] = nr[pom2+1];
        nr[pom2+1] = odkl;
      }
    }
    pos = pos + pom + 6;           						//preskoceni protokolu zpravy
    pom = hex2bin(copy(in, bfr, pos, 2)); 				//kodovani (odskouseno pouze 7 bitove)
    if (pom == 246) cod7bit = 0;						//8 bitove kodovani
   	if ((pom!=0)&&(pom!=246)&&(pom!=241)) return -2;    //nezname kodovani... unicode...
    pos = pos + 16;										//preskocani casu
    nrch = hex2bin(copy(in, bfr, pos, 2));				//pocet znaku v SMS
	pos = pos + 2;
  }  
  else return -1;

  pom = 0; 												//smazani pomocnych pormenych
  pom2 = 0;
  pom3 = 0;
// - prevod hex dvojic na bin --------------------------------------------------------------------------
  while (pom < nrch*2) 
  {
    bfr[0] = in[pom+pos];								//nacteni dvojice znaku
    bfr[1] = in[pom+pos+1];
    if (pom3 == 8) 										//kazdy 8my znak prazdny
	{
	  pom2++;
      pom3 = 1;
	}
    in[pom2] = hex2bin(bfr);							//volani funkce pro prevod dvojice
    pom3++;												//pro vytvareni prazdnych znaku
    pom2++;												//citac pozice vystupniho bufferu
    pom = pom+2;										//citac pozice vstupniho bufferu
  }
  in[pom2++]='\0';

// - prevod z 7b kodovani do 8b ------------------------------------------------------------------------
  pom3 = 0;												//smazani citace rotace
  if (cod7bit)
  for (pom = 0; pom < nrch;pom++)				
  {
    maskovadlo =  maskovadlo >> 1;  					//rotace promene urcene pro maskovani
    maskovadlo =  maskovadlo | 0x80;
   	odkl = in[pom] & maskovadlo;						//odlozeni "prenosu" do odkl pomoci maskovadla
    in[pom] = in[pom] << pom3;							//rotace znaku
    for (pom2 = 0; pom2 < (8-pom3);pom2++)				//rotace odkl2
    {
      odkl2 = odkl2 >> 1;
      odkl2 = odkl2 & 127;    
    }
	in[pom] = in[pom] | odkl2;							//pridani odkl2 ke znaku
    in[pom] = in[pom] & 127; 							//smazani nejvysiho bitu
    odkl2 = odkl;										//ulozeni odlk na dalsi pruchod
 	pom3++;												//inkrementace citace rotace
	if (pom3 == 8)										//kazdy 8my znak
    {
      pom3 = 0;											//smaz citac
	  in[pom+1] = odkl2;								//uloz 8my znak vznikly z "prenosu"
      maskovadlo = 0;									//smaz maskovadlo
    }
  }
  in[pom]='\0'; 
  return 0;
}

// - ZAKODAVANI TELEFONIHO/SMSC CISLA ------------------------------------------------------------------
//
//   VST:  char* nrs               - vstupni cislo
//         bit smsc                - typ kodovani (0 - telefoni cislo, 1 - cislo smsc)
//   VYST: char *nrs; return *char - zakodovane cislo
// -----------------------------------------------------------------------------------------------------
char *encodeNR(char *nrs, bit smsc)
{
  char idata pom, odkl;									//pmocne promene 
  char idata bufNR[20];									//odkladaci buffer
  odkl = strlen(nrs);									//odlozeni delky puvodnich dat
  bufNR[0] = '\0';										//vynulovani odkladaciho buffer
  for (pom = 0; pom < strlen(nrs); pom=pom+2)			//swap cisla
  {
    if (nrs[pom+1] != 0)
    {
      bufNR[pom] = nrs[pom+1];
      bufNR[pom+1] = nrs[pom];
    }
    else bufNR[pom]=nrs[pom];							//pri lichem poctu cisel uloz posledni znak
  }
  bufNR[pom] = '\0';									//ukonceni buffer
  nrs[0] = '\0';
  if ((strlen(bufNR) % 2) == 1) strcpy(nrs, "F");  		//pri lichem poctu cislic dej uloz pred ne F
  strcat(nrs, bufNR);
  if (smsc  == 1)  bin2hex((strlen(nrs)+2)/2,bufNR);  	//zapis delku cisla
  else  bin2hex(odkl,bufNR);
  bufNR[2] = '\0';
  strcat(bufNR, "91");									//mezinarodni format ??
  strcat(bufNR, nrs);									//nakonec to jeste slepit
  strcpy(nrs,bufNR);
  return nrs;
}

// - ZAKODAVANI ZPRAVY DO PUD FORMATU ------------------------------------------------------------------
//
//   VST:  char *inp    - vstupni text jez bude zakodovan do SMS
//         char *nr     - cislo prijemce SMS (mezinarodni format)
//         char *smscnr - cislo SMS centra
//   VYST: char *out    - zakodovana SMS do PDU formatu
//		   char *len    - "delka" PDU fomratu
// -----------------------------------------------------------------------------------------------------
void encodeSMS(char *inp, char *out, char *nr, char *smscnr, char *len)
{
  char idata mask;										//promena pro "maskovani"
  unsigned char idata pom, odk, odk2;					//pomocne odkladaci promene
  char idata buf[2];									//odkladaci promene
  char idata rot = 0;									//promene pro rotace
  char idata rot2, nrlen;

// - enkodovani cisla, cisla smsc + jeste nejaky ten balast --------------------------------------------
  strcpy(out, encodeNR(smscnr,1));						//cislo sms-centra
  nrlen = strlen(smscnr);								//ulozime si delku cisla pro pozdejsi vypocet
  strcat(out,"1100");									//nejakej balast (stavova informace zpravy)
  strcat(out, encodeNR(nr,0));							//tel. cislo
  strcat(out,"0000A8");									//zase balast
  strcat(out,bin2hex(strlen(inp), buf));				//delka textu zpravy

// - enkodovani samotneho textu zpravy -----------------------------------------------------------------
  mask = 0x80;											//nulovani maskovadla
  rot2 = strlen(out);									//odlozeni postu znaku ve zprave
  for (pom = 0; pom < strlen(inp);pom++)				//hlavni kodovaci cyklus
  {
    mask = mask >> rot;									//rotace maskovadla
    odk = inp[pom]>> rot;								//rotace vstupniho buffer
    rot++;
    odk = odk | ((inp[pom+1]<<8-rot) & mask);  			//zmaskovani a prevedeni znaku

    if (rot == 8)										//kazdy 8my znak je usetren
    {
      mask = 0x80;										//znovunastaveni maskovadla a pocitadla rotaci
      rot = 0;
    }
    else
    {
      odk2 = ((odk >> 4) & 0xF) + 48;					//prevedeni na dvojici znaku
      odk = (odk & 0xF) + 48;
      if (odk > 57) odk = odk + 7;
      if (odk2 > 57) odk2 = odk2 + 7;
 	  out[rot2] = odk2;									//vraceni zakodovaneho stringu z funkce
	  out[rot2+1] = odk;
      out[rot2+2] = '\0'; 	
      rot2=rot2+2;
    }
  }

// - vypocteni velikosti PDU zpravy --------------------------------------------------------------------
  pom = (strlen(out) - nrlen)/2-5;						//vyppocet delky sms zpravy v pdu formatu
  if (pom > 99) odk = 2;								//urceni velikosti stringu pro konverzi
  else odk = 1;
  len[odk+1] = '\0';									//ukonceni stringu
  while (pom > 0)										//prevod z int na str pomoci deleni 10
  {
    odk2 = pom % 10;
    pom = pom / 10;
    len[odk] = odk2 + '0';        
    odk--;
  }
}
