// -----------------------------------------------------------------------------------------------------
//
//   STR.C
//
//   rozsireni rutin pro praci ze stringy, 30.3.2005
//   (na platforme nezavisly kod)
//
// -----------------------------------------------------------------------------------------------------

#include <str.h>
#include <string.h>
#include <ctype.h>


// - KOPIROVANI SUBSTRINGU ZE VSTUPNIHO STRINGU (analogie prikazu copy v pascalu) ----------------------
//
//   VST:  char *in               - vstupni string
//         char pos               - pozice od ktere zacit kopirovat
//         char len               - pocet znaku pro zkopirovani
//   VYST: char *out; return char - vysledny zkopirovany string
// -----------------------------------------------------------------------------------------------------
char *copy(char *in, char *out, char pos, char len)
{
  int idata pom;
  for (pom = 0; pom < len; pom++) out[pom] = in[pom+pos];	//kopirovani potrebneho porctu znaku
  out[pom++]='\0';											//zakoncovaci nula
  return(out);
}

// - PREVOD DVOU HEX ZNAKU NA JEDEN BYTE ---------------------------------------------------------------
//
//   VST:  char *in    - vstupni dva hex znaky
//   VYST: return char - vystup prevodu
// -----------------------------------------------------------------------------------------------------
char hex2bin(char *in)
{
  if (in[1] == 0) in[1] = '0';							    //pripadne vynulovani druheho znaku
  in[0] = in[0] - '0';								        //odecteni 48 od vstupu
  in[1] = in[1] - '0';									
  if (in[0] > 9) in[0] = in[0] - 7;		      		        //pri znacich A-F odecti jeste 7
  if (in[1] > 9) in[1] = in[1] - 7; 
  in[0] = in[0] << 4;									    //posun dolniho bytu o 4
  in[0] |= in[1];										    //zapis horniho bytu do dolniho
  return (in[0]);
}

// - PREVOD BYTE NA DVA HEX ZNAKY  ---------------------------------------------------------------------
//
//   VST:  char odk                - char jez bude preveden
//   VYST: char *out; return *char - vysledne dva hex znaky
// -----------------------------------------------------------------------------------------------------
char *bin2hex(char odk, char *out)
{
  out[0] = ((odk >> 4) &  0xF) + 48;						//vypocet prvnuho znaku + 48 a rotace o 4
  out[1] = (odk & 0xF) + 48;								//vypocet druheho znaku + 48 (=0)
  if (out[0] > 57) out[0] = out[0] + 7;						//pokud A - F tak pricti jeste 7
  if (out[1] > 57) out[1] = out[1] + 7; 
  return out;
}

// - HLEDANI SUBSTRINGU VE STRINGU (OD POZICE 0, S KONVERZI NA VELKE PISMENA) --------------------------
//
//   VST:  char *imp  - vstupni string
//         char *test - substring na nez je testovan string
//   VYST: return bit - 1 = substring nalzen (0 = nenelezen)
// -----------------------------------------------------------------------------------------------------
bit find(char *imp, char *test)
{
  unsigned char idata pom;
  if (strlen(test) == 0) return 0;
  for (pom = 0; pom < strlen(test); pom++) if (test[pom] != toupper(imp[pom])) return 0;
  return 1;
}					    
