// -----------------------------------------------------------------------------------------------------
//
//   UFR.C
//
//   pomocne funkcni rutiny, 21.4.2005
//   (na platforme nezavisly kod)
//
// -----------------------------------------------------------------------------------------------------

#include <ufr.h>
#include <str.h>
#include <string.h>


// - DEKLARACE PREDDEFINOVANYCH KONSTANT ---------------------------------------------------------------
char code sepnuti[]="SEPNUTI VSTUPU ";
char code vypnuti[]="VYPNUTI VSTUPU ";
char code stavvst[]=" (I: ";
char code stavvys[]=", O: ";

// - TEST NA POVOLENY STRING ---------------------------------------------------------------------------
//
//   VST:  char *NR     - cislo jez se bude testovat
//         char *config - konfiguracni string (_<cislo 1>A<cislo 2>B<cislo 3>C<info>)
//   VYST: return bit   - cislo (1 - zname, 0 - nezname)
//		   char *len    - "delka" PDU fomratu
// -----------------------------------------------------------------------------------------------------
bit accessNR(char *NR, char *config)
{
  char idata temp[15];																	 //pomocny buffer
  copy(config, temp, 2, strpos(config, 'A')-2);											 //prvni cislo
  if (find(NR, temp)) return 1;															 //jeho test
  copy(config, temp, strpos(config, 'A')+1, strpos(config, 'B')- strpos(config, 'A')-1); //druhe cislo
  if (find(NR, temp)) return 1;															 //test...
  copy(config, temp, strpos(config, 'B')+1, strpos(config, 'C')- strpos(config, 'B')-1); //treti cislo
  if (find(NR, temp)) return 1;															 //test...
  return 0;																				 //nezname
}

// - VYTVORENI INFORMACNIHO STRINGU O PORTU ------------------------------------------------------------
//
//   VST:  char *uk	 			  - pouze predani ukazatele pro vystup
//         char pt 		          - predani stavu portu
//   VYST: char *uk; return *char - vystupni text
//		   bit neg				  - provest negaci
//------------------------------------------------------------------------------------------------------
char *portInfo(char *uk, char pt, bit neg)
{
  char idata i;									//pomocna promena
  for (i = 7; i >= 0; i--)						//cyklus 8 - 1 pro vycitani
  {
     if (neg) uk[i] = (1-(pt & 1))+'0';			//je-li neg pak sejmi bit pomoci masky a pak neguj
     else uk[i] = (pt & 1)+'0';					//bez negace
 	 pt=pt>>1;									//rotace masky
  }
  uk[8] = '\0';									//ukonceni
  return uk;
}

// - VYTVORENI TEXTU PRO ODESLANI ----------------------------------------------------------------------
//
//   VST:  char *outtext 			   - pouze predani ukazatele pro vystup
//         char por 				   - zmena vstupu cislo
//         bit typ       			   - typ (1=sepnuti, 0=vypnuti)
//		   char	prtin				   - vstupni port
//		   char	prtout				   - vystupni port
//		   char	zm					   - vytvorit text o zmene
//   VYST: char *outtext; return *char - vystupni text pro odeslani
// -----------------------------------------------------------------------------------------------------
char *createSMS(char *outtext, char por, bit typ, char prtin, char prtout, bit zm)
{
  char idata tp[10];
  if (zm)
  {
    if (typ) strcat(outtext,sepnuti);			//zapsani uvodniho textu podle
    else strcat(outtext,vypnuti);
    outtext[15] = 8 - por + '0';				//cislo vstupu
    outtext[16] = '\0';							//zakonceni 
  }
  strcat(outtext, stavvst);						//prilep text
  strcat(outtext, portInfo(tp, prtin,1)); 		//stav vstupu
  strcat(outtext, stavvys); 					//prilep text
  strcat(outtext, portInfo(tp, prtout,0)); 		//stav vystupu
  strcat(outtext, ")");							//ukonci zavorkou
  return outtext;								//return
}
